//  SettingsPanel.h
//
// 	This panel will get user settings. 
// 
//	russ 5/21/98
// 
//	Copyright 1997-1999, Be Incorporated.   All Rights Reserved.
//	This file may be used under the terms of the Be Sample Code License.

#ifndef _SETTINGSPANEL_H
#define _SETTINGSPANEL_H

#include "Resource.h"

class BCallbackHandler;

class SettingsPanel : public BWindow
{
	public:
		SettingsPanel(BCallbackHandler* cb);
		~SettingsPanel();
		
		virtual void MessageReceived(BMessage *msg); 

		void SetVpi(uint16 vpi);
		void SetVci(uint16 vci);		
		void SetShowPackets(const bool showPackets);
		
		void GetVpi(uint16 *vpi);
		void GetVci(uint16 *vci);		
		void GetShowPackets(bool* showPackets);

		
		uint16 m_vpi;
		uint16 m_vci;
		bool   m_showPackets;
		bool   m_pingReply;
		bool   m_showBroadcasts;
		
	private:
		BCallbackHandler* m_CallBack;
		BBox*			m_MainBG;
		BStringView* 	m_Label;
		BTextControl*	m_vpiCtl;
		BTextControl*	m_vciCtl;
		BCheckBox*		m_showPacketsCtl;
		
		BButton*		m_CancelBtn;
		BButton*		m_DoneBtn;
		
		void CreatePanelUI(); 
		void Update(int16 direction);
};		

#endif // _SETTINGSPANEL_H