/*
	Copyright 1999, Be Incorporated.   All Rights Reserved.
	This file may be used under the terms of the Be Sample Code License.
*/
/*
 * Common methods for speed_touch device
 */
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <Drivers.h>
#include "speed_touch_ctl.h"
#include "atm.h"
#include <fcntl.h>
#include "NetBufList.h"
#include <add-ons/net_server/NetDevice.h>


class AtmDevice : public BNetDevice {
	int fd;
	int nonblock;
	_NetBufList packetlist;
	void fill_packetlist(void);
	BNetPacket *read_packet(void);
	int got_address;
	char address[6];
	unsigned framesize;
public: 
	AtmDevice(void) {
		fd = -1;
		nonblock = 0;
		got_address = 0;
		framesize = 0;
	}
	BIpDevice *OpenIP(void) {
		return (NULL);
	}
	BNetPacket *AllocPacket(void) {
		return (new BStandardPacket());
	}
	BNetPacket *ReceivePacket(void);
	void SendPacket(BNetPacket *packet) {
		write(fd, packet->Data(), packet->Size());
		delete packet;
	}
    void Address(char *address) {
		if (!got_address) {
			ioctl(fd, STUSB_GET_MAC_ADDR, this->address);
			got_address = 1;
		}
		memcpy(address, this->address, sizeof(this->address));
	}
	status_t AddMulticastAddress(const char *address) {
		return (B_OK);
	}
	status_t RemoveMulticastAddress(const char *address) {
		return (B_OK);
	}
	status_t SetPromiscuous(bool yes) {
		return (B_OK);
	}
	unsigned MaxPacketSize(void) {
		if (framesize == 0) {
			if (ioctl(fd, STUSB_GET_FRAME_SIZE, &framesize) < 0) {
				framesize = 2120;
			}
		}
		return (framesize);
	}
	net_device_type Type(void) {
		return ((net_device_type)ATM_DEVICE);
	}
	void Statistics(FILE *f) {
	}
    int SetMaxPacketSize(unsigned framesize) {
		if (framesize > 1514) {
			return (B_ERROR);
		}
		return (B_NO_ERROR);
	}
	status_t GetLinkStatus(bool &Up) {
		status_t  status;
		int link;

		status = ioctl(fd, STUSB_GET_LINK_STATE, &link);
		Up = link;
		return(status);
	}
    void Close(void) {
		if (fd >= 0) {
			close(fd);
			fd = -1;
		}
	}
	int Init(const char *devicelink, char *params);
};
