#ifndef USB_LANGIDS_H
#define USB_LANGIDS_H

// USB Language Identifiers, 3/29/2000, version 1.0
// (USB_LANGIDs.pdf)

#define USB_LANGIDS_VERSION		0x0100	// version 1.0

// descriptor string index 0 = supported LANGIDs array
#define USB_LANGIDS_STRING_INDEX	(0)


enum {
	USB_LANGID_AFRIKAANS				= 0x0436,	// Afrikaans
	USB_LANGID_ALBANIAN					= 0x041c,	// Albanian
	USB_LANGID_ARABIA_SAUDI_ARABIA		= 0x0401,	// Arabic (Saudi Arabia)
	USB_LANGID_ARABIA_IRAK				= 0x0801,	// Arabic (Irak)
	USB_LANGID_ARABIA_EGYPT				= 0x0c01,	// Arabic (Egypt)

	USB_LANGID_ENGLISH_UNITED_STATES	= 0x0409,	// English (United States)	
	USB_LANGID_ENGLISH_UNITED_KINGDOM	= 0x0809,	// English (United Kingdom)	
	USB_LANGID_ENGLISH_AUSTRALIAN		= 0x0c09,	// English (Australian)	
	USB_LANGID_ENGLISH_CANADIAN			= 0x1009,	// English (Canadian)	
	USB_LANGID_ENGLISH_NEW_ZEALAND		= 0x1409,	// English (New Zealand)	
	USB_LANGID_ENGLISH_IRELAND			= 0x1809,	// English (Ireland)	
	USB_LANGID_ENGLISH_SOUTH_AFRICA		= 0x1c09,	// English (South Africa)	
	USB_LANGID_ENGLISH_JAMAICA			= 0x2009,	// English (Jamaica)	
	USB_LANGID_ENGLISH_CARIBBEAN		= 0x2409,	// English (Caribbean)	
	USB_LANGID_ENGLISH_BELIZE			= 0x2809,	// English (Belize)	
	USB_LANGID_ENGLISH_TRINIDAD			= 0x2c09,	// English (Trinidad)	
	USB_LANGID_ENGLISH_ZIMBABWE			= 0x3009,	// English (Zimbabwe)	
	USB_LANGID_ENGLISH_PHLIPPINES		= 0x3409,	// English (Philippines)	
	USB_LANGID_ESTONIAN					= 0x0425,	// Estonian
	USB_LANGID_FAEROESE					= 0x0438,	// Faeroese
	USB_LANGID_FARSI					= 0x0429,	// Farsi
	USB_LANGID_FINNISH					= 0x040b,	// Finnish
	USB_LANGID_FRENCH_STANDARD			= 0x040c,	// French (Standard)
	USB_LANGID_FRENCH_BELGIAN			= 0x080c,	// French (Belgian)
	USB_LANGID_FRENCH_CANADIAN			= 0x0c0c,	// French (Canadian)
	USB_LANGID_FRENCH_SWITZERLAND		= 0x100c,	// French (Switzerland)
	USB_LANGID_FRENCH_LUXEMBOURG		= 0x140c,	// French (Luxembourg)
	USB_LANGID_FRENCH_MONACO			= 0x180c,	// French (Monaco)
	USB_LANGID_GEORGIAN					= 0x0437,	// Georgian
	USB_LANGID_GERMAN_STANDARD			= 0x0407,	// German (Standard)
	USB_LANGID_GERMAN_SWITZERLAND		= 0x0807,	// German (Switzerland)
	USB_LANGID_GERMAN_AUSTRIA			= 0x0c07,	// German (Austria)
	USB_LANGID_GERMAN_LUXEMBOURG		= 0x1007,	// German (Luxembourg)
	USB_LANGID_GERMAN_LIECHTENSTEIN		= 0x1407,	// German (Liechtenstein)

	USB_LANGID_INVALID					= 0x0000	// Invalid LANG ID
};

#endif	// USB_LANGIDS_H

