// BeOS USB driver for Alcatel Speed Touch USB ADSL modem
// SAR layer
#ifndef __SAR_H__
#define __SAR_H__

#define ATM_CELL_SIZE      53
#define ATM_CELL_DATA      48
#define ATM_CELL_HEADER    05
#define AAL5_CPCS_MAX_SIZE (9180 + ATM_CELL_DATA) // CIP max MTU
#define RX_BUFFER_QTY      4

// VPI (8/35(wanadoo)  0/21(operator loopback))
#define DEFAULT_VPI        8   // 0
#define DEFAULT_VCI        35  // 21


#define DEFAULT_HEC        0xEC
#define DEFAULT_GFC        0x00

#define SAR_THREAD_NAME  "stusbSarThread"
#define SAR_THREAD_PRIO  30
#define STUSB_RXBUF_SIZE (64*ATM_CELL_SIZE)

// SAR service setup
status_t start_sar_service(device *dev, uint8 * buf);

// SAR service cleanup
status_t stop_SAR_service(device *dev);

// PDU read service
status_t sar_read(device *dev, uint8 *buffer, uint32 *len);

// PDU write service
status_t sar_write(device *dev, uint8 *buffer, uint32 *len);

#endif //__SAR_H__