#ifndef __AAL5_PACKET_H__
#define __AAL5_PACKET_H__

#include <add-ons/net_server/NetPacket.h>
#include <add-ons/net_server/NetDevice.h>
#include <support/ByteOrder.h>


#define MAX_PDU_LEN        1536

#define NET_ENDIAN(a)  swap_data(B_UINT16_TYPE,&a,sizeof(a),B_SWAP_HOST_TO_BENDIAN)
#define FROM_NET_ENDIAN(a)  swap_data(B_UINT16_TYPE,&a,sizeof(a),B_SWAP_BENDIAN_TO_HOST)


class AAL5Packet : public BNetPacket /* BStandardPacket is a piece of crap, so do it our own way */ {
	public:
		AAL5Packet(void);
		AAL5Packet(BNetPacket *packet);
		virtual void SetData(const void *data,size_t length,uint16 offset = 0); //---Less than 1522 bytes
		virtual size_t GetData(const void *buffer,size_t length,uint16 offset = 0);
		
		virtual void Finalize(void);
		
		/* BNetPacket funcs */
		virtual unsigned Size(void);
		virtual void SetSize(unsigned size);
		virtual unsigned Base(void);		
		virtual void SetBase(int offset);	
		virtual char *DataBlock(unsigned offset, unsigned *size);
		
		virtual ~AAL5Packet(void);
		
	private:
		void *data;
		size_t size;
		int32 base;
};
		
#endif //__AAL5_PACKET_H__