#include <add-ons/net_server/NetProtocol.h>
#include <support/List.h>
#include <support/String.h>
#include <support/StopWatch.h>
#include <string.h>
#include <unistd.h>
#include "atm.h"
#include "aal5_packet.h"
#include "pppoa_packet.h"
#include "ppp_transport.h"


// debug stuff
FILE *f;

#if DEBUG_ON
	extern FILE *f;
	#include "debug.h"
#endif

#define DISCOVERY_TIMEOUT 10000000//µs

class PPPoA : public BNetProtocol, public BPacketHandler, public ppp_transport  {
	public:
		PPPoA(void);
		void AddDevice(BNetDevice *dev, const char *name);
		bool PacketReceived(BNetPacket *recv, BNetDevice *from);
		PPPPacket *AllocPacket(void);
		void SendPacketToNet(PPPPacket *send);
		void Open(void);
		void Close(void);
		~PPPoA(void);
	private:
		BList devices;
		BNetDevice *active;
};

BNetProtocol *open_protocol(const char *device) {
	PPPoA *prot = new PPPoA;
	return (BNetProtocol *)(prot);
}

PPPoA::PPPoA (void) : BNetProtocol() , ppp_transport("pppoa") {

	active = NULL;
f = fopen("/var/log/pppoa.log", "w+");
fprintf(f,"PPPoA::PPPoA\n");
fflush(f);
}

void PPPoA::AddDevice(BNetDevice *dev, const char *name) {
	if (dev->Type() != (net_device_type)ATM_DEVICE )
		return;
fprintf(f,"adding device 0x%x\n",dev->Type());
fflush(f);
	register_packet_handler(this,dev,10);
	devices.AddItem(dev);
	active = (BNetDevice *)(devices.ItemAt(0));
}

void PPPoA::Open(void) {
fprintf(f,"PPPoA::Open()\n");
fflush(f);
	linkUp = true;
}

void PPPoA::Close(void) {
fprintf(f,"PPPoA::Close()\n");
fflush(f);
	if (active == NULL)
		return;
	active = NULL;
}

void PPPoA::SendPacketToNet(PPPPacket *send) {
fprintf(f,"PPPoA::SendPacketToNet\n");
fflush(f);
	if (active == NULL)
		return;
	PPPoAPacket *packet = (PPPoAPacket *)(send);
	packet->Finalize();
	active->SendPacket(packet);
}

PPPPacket *PPPoA::AllocPacket(void) {
fprintf(f,"PPPoA::AllocPacket()\n");
fflush(f);
	return new PPPoAPacket();
}

bool PPPoA::PacketReceived(BNetPacket *recv, BNetDevice *from) {
fprintf(f,"PPPoA::PacketReceived()\n");
fflush(f);
	if (recv == NULL)
		return false;
	PPPoAPacket generic(recv);
	SendPacketToPPP(&generic);
	delete recv;
	return true;
}


PPPoA::~PPPoA(void) {
fprintf(f,"We've been deleted! Phooey.\n");
		fflush(f);
		fclose(f);
}
